Subject: Re: [MEXT] Comments on draft-ietf-mext-binding-revocation-02

From: "Ahmad Muhanna" <[email-masked]>
Date: Tue, 6 Jan 2009 09:23:24 -0600

Hi Patrick,
It seems that I never responded to your responses. 
Please see responses inline.

Regards,
Ahmad
 
> > 
> > > -----Original Message-----
> > > From: Stupar, Patrick [mailto:[email-masked]]
> > > Sent: Wednesday, December 10, 2008 7:19 PM
> > > To: Muhanna, Ahmad (RICH1:2H10)
> > > Cc: [email-masked]
> > > Subject: Comments on draft-ietf-mext-binding-revocation-02
> > >
> > > Hi Ahmad,
> > >
> > > I have reviewed binding revocation draft and have the following 
> > > comments/questions.
> > >
> > > - In MIPv6, Binding Update and Binding Ack have two different MH 
> > > type values. Why isn't the same approach taken for BRI 
> and BRA and 
> > > only one value is used?
> > 
> > [Ahmad]
> > This was discussed on the mailing list for a long time and 
> agreed that 
> > using one MH type will help in preserving the MH type 
> space. I believe 
> > the "Heartbeat Mechanism for PMIPv6" is a wg doc in Netlmm 
> and use one 
> > MH type for the Request and Response. On the other hand, do see an 
> > issue or problem in having a single MH type for both messages?
> 
> [Patrick] If the WG is worried about MH type space then I am 
> fine with the proposed message format.
> 
> > 
> > >
> > > - BRI has a revocation trigger field which is used for two main 
> > > usages.
> > > One is the provisioning of the reason why the revocation was sent 
> > > (e.g.
> > > inter-MAG handoff) and the other is related to specific binding 
> > > revocation procedures (e.g. IPV4 HoA Binding only, 
> Per-Peer Policy). 
> > > I think it would be cleaner if the two concepts remain 
> separated in 
> > > the messages, for instance defining additional flags for Per-peer 
> > > policy or
> > > IPv4 HoA Binding only.
> > 
> > [Ahmad]
> > I see what you are saying. However, as you said, the Revocation
> Trigger
> > field is defined to give the reason which caused the 
> revoking node to 
> > send the BRI message. Thus far, I believe all of the defined values
> are
> > inline with that definition or reasoning. For example: When the LMA 
> > sets the R. Trigger value to "IPv4 HoA Binding Only" it 
> means that the 
> > reason behind sending this BRI message is to revoke the IPv4 HoA 
> > address in the case that the MN is assigned two proxy 
> HoA(v4 & v6) for 
> > the same pCoA.
> > I
> > do not see this as a policy decision, because it is no 
> difference from 
> > the MAG sending a BRI with R. Trigger value is set to for example, 
> > "Access Network Session Termination"
> > 
> > As for the R. Trigger value of "Per-Peer Policy", This is only 
> > restricted to Global Revocation when the (G) bit is set. I still 
> > believe that "Per-Peer policy" also indicate the reason 
> that allowed 
> > the LMA
> to
> > send this Global BRI. Do you have a different name for this 
> R. Trigger 
> > value that would fit better?
> > 
> 
> [Patrick]IMHO "IPv4 HoA Binding Only" is not the reason that 
> triggered the BRI, it's the action that the MN is requested 
> to perform. Anyhow, my concerns were not related to the list 
> of reasons in the revocation trigger, but to the fact that 
> some values of the field imply some actions and other values 
> don't. My suggestion is that the actions are taken by MN and 
> HA based on flags (e.g. Global Revocation) and not on the 
> revocation trigger. Only the case of "IPv4 HoA Binding Only" 
> lacks of a proper flag.

[Ahmad]
After pondering on this, it seems to me that makes sense. Will introduce
a flag for "IPv4 HoA Revocation Only" and update the draft accordingly.
This will cause some text changes to capture all cases which relates to
Client MIP6 and PMIPv6; will take care of it in the new revision,
hopefully in the next week.

> 
> 
> > >
> > > - In the draft you refer to MAG identity, where is this term 
> > > defined? I wasn't able to find it in RFC 5213.
> > 
> > [Ahmad]
> > Actually, under section 4.1. "Peer Authorization Database (PAD)
> Example
> > Entries", you can find the MAG-ID is defined there as 
> mag_identity_1.
> > It
> > is the same concept here. However, I agree that we do not have a 
> > mobility option which is specific for carrying MAG-ID but 
> the draft is 
> > using the MN-ID in a very specific scenario. How the LMA would check
> if
> > this MAG is authorized for Global revocation is out of scope.
> > 
> 
> [Patrick] what I meant here is that in section 2 of RFC5213 
> there is the definition of MN identity and that I would 
> expect something similar for the MAG in BRI draft. For MN 
> identity, RFC5213 claims that MAC address or NAI can be used. 
> Are there similar guidelines for MAG identity? 

[Ahmad]
I see what you are saying. I assumed that this is in the form of NAI. we
can add some text to clarify that, would that address your concern or
you have in mind a possible different format? 
 
> 
> 
> > >
> > >
> > > Some other comments related to specific sections:
> > >
> > > - page 21: in the first section after the bullet list, 
> there is the 
> > > following sentence:
> > > "As described in Section 7.3, the LMA SHOULD retransmit 
> this BRI to
> > >    the MAG before deleting the mobile node IP tunnel to the mobile
> > >    access gateway until it receives a matching Binding Revocation
> > >    Acknowledgement or the BRIMaxRetransmitNumber is reached. "
> > > But this doesn't always apply, e.g. in case of inter-mag 
> handoffs. 
> > > What am I missing?
> > 
> > [Ahmad]
> > Yes, I see what you are saying here. It seems that the text 
> needs some 
> > tweaking.
> > Do you have any suggestion?
> [Patrick] How about referring to the BCE?
> Proposed text:
> "As described in Section 7.3, the LMA SHOULD retransmit this 
> BRI to the MAG before deleting BCE until it receives a 
> matching Binding Revocation Acknowledgement or the 
> BRIMaxRetransmitNumber is reached. " 
> Though I am not sure this text is helpful as it is already 
> captured later in the draft.

[Ahmad]
When talking about deleting the BCE, it may conflict with the case of
inter-MAG handoff. I believe leaving the term deleting the tunnel is
more generic. In other words, LMA may delete the IP tunnel but NOT the
BCE in some cases. However, in other cases which does not involve
inter-MAG handoff, when deleting the IP tunnel, consequently, the BCE
will be deleted.
 
> 
> 
> > 
> > >
> > > - why is the A bit setting mandatory in case of IPv4 HoA binding 
> > > only revocation?
> > 
> > [Ahmad]
> > May be if you tell me why not, we could change it?
> 
> [Patrick] I have nothing against it. But that "MUST" implies 
> that a BRI with the "IPv4 HoA Binding Only" value in the 
> revocation trigger field and A bit not set is not properly 
> formatted. What does the MAG do in this case?

[Ahmad]
I believe that "MUST" is needed because revoking the IPv4 HoA address
only does not mean deleting the BCE, In other words, the MAG should
maintain the IPv6 HoA Binding and a PBA is needed to confirm to the LMA
that the MAG will continue maintaining the IPv6 binding. However, the
case you mentioned is an error scenario and we may have two ways to do
it:

1. The MAG to ignore the BRI
2. The MAG MUST treat this as if the 'A' bit is set and MUST send a PBA.

After introducing the "IPv4 HoA Revocation Only" flag, I believe the
proper behavior is No. 2 above.

> 
> > 
> > >
> > > - section 10.1.1:
> > > "BRI MUST be formatted as in Section 6.1 and if the (P) 
> bit is set,
> > >       the mobile access gateway must validate that the impacted 
> > > binding
> > >       have the proxy binding flag set."
> > > MAG is not supposed to have any proxy binding flag or is it?
> > > How can it validate this flag?
> > 
> > [Ahmad]
> > Good catch. There is another incident below it too.
> > What about the following text for both bullets:
> > "
> >    o  BRI MUST be formatted as in Section 6.1 and the (P) 
> bit is set.
> > 
> >    o  If the Global (G) bit is set and the Revocation 
> Trigger field is
> >       set to "Per-Peer policy", the mobile access gateway 
> identify all
> >       bindings that are registered at the LMA and hosted at the MAG.
> >       This Binding Revocation Indication does not include any other
> >       mobility options. In this case, the MAG MUST send a 
> BRA with the
> >       appropriate status code to the LMA.
> > "
> > 
> 
> [Patrick] fine with me, thanks
> 
> > >
> > >
> > > -section 11.1
> > > " If the Acknowledgement (A) bit is set in the Binding Revocation
> > >       Indication and the MN has the BCE in registered state, the 
> > > mobile
> > >       node MUST send a Binding Revocation Acknowledgement."
> > >
> > > MN has no BCE, it has a binding update list.
> > [Ahmad]
> > Right. Thx. What about the following:
> > 
> >    o  If the Acknowledgement (A) bit is set in the Binding 
> Revocation
> >       Indication and the MN has a Binding Update List entry for the 
> > source
> >       of the BRI message, the mobile node MUST send a Binding 
> > Revocation
> > 
> >       Acknowledgement. However, in all other cases when the 
> (A) bit is 
> > set
> >       in the BRI, the mobile node SHOULD send a Binding Revocation 
> > Acknowledgement.
> >       In all cases, the mobile node MUST follow Section 
> 11.2 when send
> >       a BRA using the appropriate status code.
> > 
> [Patrick] I would perform the check based on the HoA and CoA 
> contained in the BRI. 
> Proposed text:
> 
>    o  If the Acknowledgement (A) bit is set in the Binding Revocation
>       Indication and the MN has a Binding Update List entry 
> for the Care of address and the Home Address
>       Contained in the BRI message, the mobile node MUST send 
> a Binding Revocation
> 
>       Acknowledgement. However, in all other cases when the 
> (A) bit is set 
>       in the BRI, the mobile node SHOULD send a Binding 
> Revocation Acknowledgement.  
>       In all cases, the mobile node MUST follow Section 11.2 
> when send 
>       a BRA using the appropriate status code.
>

[Ahmad]
Currently, neither the HoA nor the CoA is included in the BRI message.
Are you suggesting that we add those options as valid ones in the BRI?
 
> 
> > >
> > > -section 11.1
> > > "If the Revocation Trigger field value is "Administrative Reason",
> > >       the mobile node MUST NOT try to re-register with the home
> agent
> > >       before contacting its home operator."
> > >
> > > I don't think that BRI specs have to mandate the MN to 
> contact the 
> > > home operator, the text at the end of section
> > > 11.1 is enough IMO.
> > >
> > [Ahmad]
> > I see your point, It seems a very strong requirement and for a well 
> > behaved MN implementation, it may not be a problem to 
> remove the whole 
> > bullet. However, for a non-well behaved MN, it may be necessary to
> keep
> > something. What about if we demote MUST NOT to SHOULD NOT. 
> Would that 
> > work?
> > 
> > 
> [Patrick] I was not worried about the "MUST" or "SHOULD", but 
> by the fact that IMO the action to be taken after receiving a 
> BRI with that value in the trigger field is implementation 
> dependant as already described later in the draft

[Ahmad]
Sure, we can remove this bullet.

Thanks for all of your comments and sorry for the late reply.

> 
> > NEW TEXT:
> >    o  If the Revocation Trigger field value is "Administrative
> Reason",
> >       the mobile node SHOULD NOT try to re-register with the home
> agent
> >       before contacting its home operator.
> > 
> > TEXT at end of 11.1 that Patrick is referring to:
> > 
> >    The Revocation Trigger field value in the received Binding 
> > Revocation
> >    Indication could be used by the mobile node to define 
> what action 
> > the
> >    mobile node could do to be able to register again and receive its
> IP
> >    mobility service, e.g. contacting its home operator.
> > 
> > > I have some typos and editorial corrections as well, I will send 
> > > them off-list.
> > 
> > [Ahmad]
> > Please send them. Thanks for your review and good comments!
> > 
> > >
> > > Regards,
> > >
> > > Patrick
> > >
> 
_______________________________________________
MEXT mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/mext

---

From: "Ahmad Muhanna" <[email-masked]>
Date: Tue, 6 Jan 2009 09:36:46 -0600

Minor typo correction.

Regards,
Ahmad

> 
> [Ahmad]
> I believe that "MUST" is needed because revoking the IPv4 HoA 
> address only does not mean deleting the BCE, In other words, 
> the MAG should maintain the IPv6 HoA Binding and a PBA is 
> needed to confirm to the LMA that the MAG will continue 
> maintaining the IPv6 binding. However, the case you mentioned 
> is an error scenario and we may have two ways to do
> it:
> 

[Ahmad]
Couple of instances refer to PBA, I meant to say BRA.

> After introducing the "IPv4 HoA Revocation Only" flag, I 
> believe the proper behavior is No. 2 above.
> 
>

---

From: "Stupar, Patrick" <[email-masked]>
Date: Fri, 16 Jan 2009 17:17:31 -0000

Hi Ahmad

I think most of the discussion we had is solved. Please find one last
comment below.

Best Regards,

Patrick 

> From: Ahmad Muhanna [mailto:[email-masked]]
> Sent: Tuesday, January 06, 2009 4:23 PM
> To: Stupar, Patrick
> Cc: [email-masked]
> Subject: RE: Comments on draft-ietf-mext-binding-revocation-02
> 
> Hi Patrick,

I think this would be good. Either a definition in section 2.2 or a
clarification in the text would be fine with me.

> inter-MAG handoff, when deleting the IP tunnel, consequently, the BCE

Fine with me.

> proper behavior is No. 2 above.

Behavior 2 implies that PBA is mandatory, not the setting of the ACK,
but I can live with that :-)
 
Revocation
> Are you suggesting that we add those options as valid ones in the BRI?

No I am not. What I meant here is that HoA is in the routing header of
the packet containing the BRI. Checking of HoA would be enough IMO. It
could be moved to the previous bullet of the list as in the following
proposed text:
OLD TEXT:
"
   o  The mobile node MUST verify that the IP address in the type 2
      routing header is its Home Address.

   o  If the Acknowledgement (A) bit is set in the Binding Revocation
      Indication and the MN has the BCE in registered state, the mobile
      node MUST send a Binding Revocation Acknowledgement.  However, in
      all other cases when the (A) bit is set in the BRI, the mobile
      node SHOULD send a Binding Revocation Acknowledgement.  In all
      cases, the mobile node MUST follow Section 11.2 when send a BRA
      using the appropriate status code.
"
NEW TEXT
"
   o  The mobile node MUST verify that the IP address in the type 2
      routing header is its Home Address and that its Binding Update 
	List contains an entry for that Home Address. If one of the
tests fails, 
	the mobile node SHOULD silently discard the received BRI
      message.

   o  If the Acknowledgement (A) bit is set in the Binding Revocation
      Indication, the mobile
      node MUST send a Binding Revocation Acknowledgement.  However, in
      all other cases when the (A) bit is set in the BRI, the mobile
      node SHOULD send a Binding Revocation Acknowledgement.  In all
      cases, the mobile node MUST follow Section 11.2 when send a BRA
      using the appropriate status code.
"

Please note that the proposed text overlaps with the last bullet listed
in section 11.2. I would remove that as in the following:

Old text:
"11.2.  Sending Binding Revocation Acknowledgement

   When the mobile node receive a valid Binding Revocation Indication
   with the (A) bit is set from its home agent and while having this BCE
   in registered state, the mobile node MUST send a packet to its home
   agent containing a Binding Revocation Acknowledgement according to
   the procedure in Section 7.1 and the following:

   o  The mobile node MUST set the status field to successful to reflect
      that it has received the Binding Revocation Indication and
      acknowledge that its IP connectivity with its home agent has been
      revoked.

   o  The destination IP address of the IPv6 packet of the Binding
      Revocation Acknowledgement is set to the source IP address of the
      received IPv6 packet of the Binding Revocation Indication.  The
      Mobile Node MUST include its home address in the Home Address
      option in the Destination Option.

   o  If the mobile node receives a Binding Revocation Indication from a
      home agent which the mobile node does not have a registered
      binding with, the mobile node SHOULD silently discard the BRI
      message.  The mobile node should continue to use its assigned HoA
      to access its IP mobility service."

New text:
"11.2.  Sending Binding Revocation Acknowledgement

   When the mobile node receive a valid Binding Revocation Indication
   with the (A) bit is set from its home agent and while having this BCE
   in registered state, the mobile node MUST send a packet to its home
   agent containing a Binding Revocation Acknowledgement according to
   the procedure in Section 7.1 and the following:

   o  The mobile node MUST set the status field to successful to reflect
      that it has received the Binding Revocation Indication and
      acknowledge that its IP connectivity with its home agent has been
      revoked.

   o  The destination IP address of the IPv6 packet of the Binding
      Revocation Acknowledgement is set to the source IP address of the
      received IPv6 packet of the Binding Revocation Indication.  The
      Mobile Node MUST include its home address in the Home Address
      option in the Destination Option."

---

From: "Ahmad Muhanna" <[email-masked]>
Date: Fri, 16 Jan 2009 12:50:50 -0600

Hi Patrick,
Thanks. One slight modification below.

Regards,
Ahmad

> Sent: Friday, January 16, 2009 11:18 AM
> > I see what you are saying. I assumed that this is in the 
> form of NAI.
> > we
> I think this would be good. Either a definition in section 
> 2.2 or a clarification in the text would be fine with me.

[Ahmad]
Sure.

> No I am not. What I meant here is that HoA is in the routing 
> header of the packet containing the BRI. Checking of HoA 
> would be enough IMO. It could be moved to the previous bullet 
> of the list as in the following proposed text:
> OLD TEXT:
> "
> 	List contains an entry for that Home Address. If one of 
> the tests fails, 

[Ahmad]
I am not sure I follow the second bullet of the "NEW TEXT". What about
the following modified text:

"MODIFIED TEXT"

   o  The mobile node MUST verify that the IP address in the type 2
      routing header is its Home Address and that its Binding Update 
	List contains an entry for that Home Address. If one of the
tests, 
	fails the mobile node SHOULD silently discard the received BRI
      message.

   o  If the Acknowledgement (A) bit is set in the Binding Revocation
      Indication and its Binding Update List contains an entry for the 
      IP address in the type 2 routing header, the mobile node MUST
      send a Binding Revocation Acknowledgement.  However, in
      all other cases when the (A) bit is set in the BRI, the mobile
      node SHOULD send a Binding Revocation Acknowledgement.  In all
      cases, the mobile node MUST follow Section 11.2 when send a BRA
      using the appropriate status code.

> 
> Please note that the proposed text overlaps with the last 
> bullet listed in section 11.2. I would remove that as in the 
> following:
> 
> Old text:

[Ahmad]
Sure. That is fair and good.

Best Regards,
Ahmad

---

From: "Stupar, Patrick" <[email-masked]>
Date: Mon, 19 Jan 2009 18:59:40 -0000

Hi Ahmad,

Please see below.

Best Regards,

Patrick

> Sent: Friday, January 16, 2009 7:51 PM
> To: Stupar, Patrick
> Cc: [email-masked]
Revocation
Revocation
>       using the appropriate status code.
[Patrick]
The actions in the first bullet apply to any received BRI (also to those
with the A bit set). Having said that, in the second bullet it is only
required  to specify the additional operation (i.e. sending a BRA) the
MN has to perform when the A bit is set. IMO the text you added is
redundant and not required. Do you have some particular scenario I am
missing?

---

From: "Ahmad Muhanna" <[email-masked]>
Date: Mon, 19 Jan 2009 17:23:21 -0600

Hi Patrick,

As I said, your proposed text for the second bullet was not clear to me.
On the other hand, the first bullet specify what happened if any of the
two checks fail, i.e. if the received BRI does not have an entry in its
BUL.

The second bullet specify what happened if these two checks were
successful. There is nothing wrong in being explicit and clear without
any ambiguity. Finally, how come your question is valid against the
clarified text and NOT against yours? 

Can I say that you have a problem with the following text: Can you
specify what is wrong in it?

   o  If the Acknowledgement (A) bit is set in the Binding Revocation
      Indication and its Binding Update List contains an entry for the 
      IP address in the type 2 routing header, the mobile node MUST
      send a Binding Revocation Acknowledgement.  

Regards,
Ahmad

> Sent: Monday, January 19, 2009 8:00 PM
> > > No I am not. What I meant here is that HoA is in the 
> routing header 
> > > of the packet containing the BRI. Checking of HoA would be enough 
> > > IMO. It could be moved to the previous bullet of the list 
> as in the 
> > > following proposed text:
> > > OLD TEXT:
> > > "
> the tests 
> > > fails,
> the tests,
> The actions in the first bullet apply to any received BRI 
> (also to those with the A bit set). Having said that, in the 
> second bullet it is only required  to specify the additional 
> operation (i.e. sending a BRA) the MN has to perform when the 
> A bit is set. IMO the text you added is redundant and not 
> required. Do you have some particular scenario I am missing?  
> 
> 
> 
> > >
> > > Please note that the proposed text overlaps with the last bullet 
> > > listed in section 11.2. I would remove that as in the
> > > following:
> > >
> > > Old text:
> > >    with the (A) bit is set from its home agent and while 
> having this 
> > > BCE
> > >       acknowledge that its IP connectivity with its home 
> agent has 
> > > been
> > >       revoked.
> > >
> > >       Revocation Acknowledgement is set to the source IP 
> address of 
> > > the
> > >       message.  The mobile node should continue to use 
> its assigned 
> > > HoA
> > >    with the (A) bit is set from its home agent and while 
> having this 
> > > BCE
> > >       acknowledge that its IP connectivity with its home 
> agent has 
> > > been
> > >       revoked.
> > >
> > >       Revocation Acknowledgement is set to the source IP 
> address of 
> > > the

---

From: "Stupar, Patrick" <[email-masked]>
Date: Tue, 20 Jan 2009 09:59:35 -0000

Hi Ahmad,

I don't think that the "MODIFIED" text you proposed is wrong, I think
that part of it is redundant and already covered. If you think that your
proposal is more suitable I can live with that. Some additional comments
below.

Regards,

Patrick 

> Sent: Tuesday, January 20, 2009 12:23 AM
> To: Stupar, Patrick
> Cc: [email-masked]

You added the sentence "and its Binding Update List contains an entry
for the IP address in the type 2 routing header": this is already
described in the previous bullet, that's why I had the comment against
your modified text and not mine. But as I said before, it's not wrong
but only redundant.

> > > >       cases, the mobile node MUST follow Section 11.2 when send
a
> > BRA
> > > >       cases, the mobile node MUST follow Section 11.2 when send
a
> > BRA
> > > >    in registered state, the mobile node MUST send a packet to
its
> > > home
> > > >    agent containing a Binding Revocation Acknowledgement
> according
> > to
> > > >    o  If the mobile node receives a Binding Revocation
Indication
> > > > from a
> > > >    in registered state, the mobile node MUST send a packet to
its
> > > home
> > > >    agent containing a Binding Revocation Acknowledgement
> according
> > to